// aviresDlg.cpp : implementation file
//

#include "stdafx.h"
#include "util.h"
#include "avires.h"
#include "aviresDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern stRes CalculateResize(stRes stInput, int iResol, int iFormat, int iDar, int iZoom);


/////////////////////////////////////////////////////////////////////////////
// CAviresDlg dialog

CAviresDlg::CAviresDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAviresDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAviresDlg)
	m_csEditX = _T("576");
	m_csEditY = _T("320");
	m_iDar = 0;
	m_iFormat = 0;
	m_iResolution = 0;
	m_iZoom = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAviresDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAviresDlg)
	DDX_Text(pDX, IDC_EDITX, m_csEditX);
	DDX_Text(pDX, IDC_EDITY, m_csEditY);
	DDX_Radio(pDX, IDC_RDAR43, m_iDar);
	DDX_Radio(pDX, IDC_RNTSC, m_iFormat);
	DDX_Radio(pDX, IDC_RRDVD, m_iResolution);
	DDX_Radio(pDX, IDC_RZOOM0, m_iZoom);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAviresDlg, CDialog)
	//{{AFX_MSG_MAP(CAviresDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAviresDlg message handlers

BOOL CAviresDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	CEdit *pCEdit;

	pCEdit = (CEdit*) GetDlgItem(IDC_EDITX);
	pCEdit->SetLimitText(4);
	pCEdit = (CEdit*) GetDlgItem(IDC_EDITY);
	pCEdit->SetLimitText(4);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAviresDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAviresDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAviresDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CAviresDlg::OnOK() 
{
	// TODO: Add extra validation here

	stRes stInput,stOutput;
	int res1,res2;
	CString csAux1,csAux2,csAux3;

	UpdateData(TRUE);

	res1 = sscanf(m_csEditX,"%d", &stInput.iX);
	res2 = sscanf(m_csEditY,"%d", &stInput.iY);
	stInput.iborderX=0;
	stInput.iborderY=0;
	stInput.iCropX=0;
	stInput.iCropY=0;

	
	if (res1!=1 || res2 !=1 )
	{
		MessageBox("Input resolution error","Error",MB_OK|MB_ICONEXCLAMATION);
		return;
	}
	if (stInput.iX <16 || stInput.iX > 8192 || stInput.iY <16 || stInput.iY > 8192  )
	{
		MessageBox("Input resolution error.\n Values should be between 16 and 8192","Error",MB_OK|MB_ICONEXCLAMATION);
		return;
	}


	stOutput=CalculateResize(stInput,m_iResolution,m_iFormat,m_iDar,m_iZoom);

	csAux1.Format(_T("Resize (%d,%d)\n"),stOutput.iX, stOutput.iY) ;

	if (stOutput.iCropX || stOutput.iCropY)
		csAux2.Format(_T("Crop (%d,%d,%d,%d)\n"),
		   stOutput.iCropX,stOutput.iCropY,-stOutput.iCropX,-stOutput.iCropY);
	else
		csAux2="";

	if (stOutput.iborderX || stOutput.iborderY)
		csAux3.Format(_T("AddBorders (%d,%d,%d,%d)\n"),
		   stOutput.iborderX,stOutput.iborderY,stOutput.iborderX,stOutput.iborderY);
	else
		csAux3="";

	MessageBox (csAux1+csAux2+csAux3,"Calculator Results",MB_OK|MB_ICONINFORMATION);
	
	return;

	CDialog::OnOK();
}
